﻿Imports System.Net
Imports System.Net.Sockets
Imports System.Threading
Imports AudioSwitcher.AudioApi.CoreAudio

Module Module1

	Sub Main()
		' ovladač hlasitosti
		Dim speaker = (New CoreAudioController()).DefaultPlaybackDevice

		' TCP server
		Dim sock As Sockets.Socket = New Socket(SocketType.Stream, ProtocolType.IP)
		sock.Bind(New IPEndPoint(IPAddress.Parse("0.0.0.0"), 1234))
		sock.Listen(1)

		' čekání a obsluhování klientů
		While True
			Dim client = sock.Accept()
			Console.WriteLine("Klient připojen. Linka obsazena.")
			' vyjimka může nastat při pádu nebo odpojení klienta. V obou dvou případech se vrátíme čekat na dalšího klienta.
			Try
				Dim buffer(100) As Byte

				' čekání a spracovávání dat přijatých od klienta
				While True
					If client.Available > 0 Then
						' čtení poslední přijaté hodnoty
						Dim received = client.Receive(buffer)
						If received > 0 Then
							Dim val = buffer(received - 1)
							If val >= 0 And val <= 100 Then
								' nastavování hlasitosti
								Console.WriteLine("Volume is set " & val)
								speaker.Volume = val
							End If
						End If
					Else
						' data nepřišla. Kontrola, že klient žije.
						If client.Poll(50, Sockets.SelectMode.SelectRead) And client.Available = 0 Then
							client.Close()
							Throw New Exception()
						End If
						client.Send(New Byte() {0})

						' je čas jít spát
						Thread.Sleep(10)
					End If
				End While

			Catch ex As Exception
				Console.WriteLine("Klient odpojen. Linka je volná.")
			End Try
		End While

	End Sub

End Module
